<?php

namespace Modules\Banner\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Banner\Enums\BannerActiveStatusEnum;
use Modules\Banner\Enums\BannerCountPhotoEnum;
use Modules\Banner\Enums\BannerStatusEnum;
use Modules\User\Enums\UserRoleEnum;

class BannerRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::admins();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('banners'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $active_statuses = implode(',',BannerActiveStatusEnum::values());
        $count = implode(',',BannerCountPhotoEnum::values());
        $rules =
        [
            'active_status'=>
            [
                'required',
                'in:'.$active_statuses
            ],
            'show_all_pages'=>
            [
                'required',
                'in:'.$active_statuses
            ],
            'count_photo'=>
            [
                'required',
                'in:'.$count
            ]
        ];
        for($i = 1 ;$i <= request('count_photo') ;$i++)
        {
            $rules['images.'.$i.'.image'] = 'required';
            $rules['images.'.$i.'.link'] =
            [
                'nullable',
                'url'
            ];
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes =
        [
            'show_all_pages'=>__('banners.show_all_pages'),
            'active_status'=>__('banners.active_status'),
            'count_photo'=>__('banners.count_photo'),

        ];
        for($i = 1 ;$i <= request('count_photo') ;$i++)
        {
            $attributes['images.'.$i.'.image'] = __('banners.image').' : '.$i;
            $attributes['images.'.$i.'.link'] = __('banners.link').' : '.$i;
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
